
#include "stdint.h"
#include "TriAngle.h"


void SwapVertices(T_Point *t, uint8_t p, uint8_t q) //function SwapVertices(var t: TTriangle; p, q: Integer): Boolean;
{
	T_Point tmp; //Tmp: TPoint;
	
	if (t[p].Y > t[q].Y) //Result := t[p].y > t[q].y; if Result then begin
	{
		tmp = t[p]; //Tmp := t[p];
		t[p] = t[q]; //t[p] := t[q];
		t[q] = tmp; //t[q] := Tmp;
	} //end;
}
 
   
T_Edge InitEdge(T_Point *t, uint8_t p, uint8_t q) //function InitEdge(t: TTriangle; p, q: Integer): TEdge;
{
	int16_t x, dx, dy; //x, dx, dy: Integer;
	T_Edge e; //e: TEdge;
	
	dx = t[q].X - t[p].X; //dx := t[q].x - t[p].x;
	dy = t[q].Y - t[p].Y; //dy := t[q].y - t[p].y;
	e.life = dy; //e.life := dy;
	dy = 2 * dy; //dy := 2 * dy;
	e.dy = dy; //e.dy := dy;
	
	if (dy == 0) //if dy = 0 then begin
	{
		return e; //Result := e; Exit;
	} //end;
	
	x = t[p].X * e.dy + dx; //x := t[p].x * e.dy + dx;
	e.xint = x / dy; //e.xint = x div dy;
	e.xfrac = x % dy; //e.xfrac = x mod dy;
	
	if (e.xfrac < 0) //if e.xfrac < 0 then begin
	{
		e.xint--; //Dec(e.xint);
		e.xfrac += dy; //Inc(e.xfrac, dy);
	} //end;
	
	dx = dx * 2; //dx := dx * 2;
	e.dxint = dx / dy; //e.dxint = dx div dy;
	e.dxfrac = dx % dy; //e.dxfrac = dx mod dy;
	
	if (e.dxfrac < 0) //if e.dxfrac < 0 then begin
	{
		e.dxint--; //Dec(e.dxint);
		e.dxfrac += dy; //Inc(e.dxfrac, dy);
	} //end;
	
	return e; //Result := e;
}


void Advance(T_Edge *e) // procedure Advance(var e: TEdge);
{
	e->xint += e->dxint; //Inc(e.xint, e.dxint);
	e->xfrac += e->dxfrac; //Inc(e.xfrac, e.dxfrac);
	if (e->xfrac >= e->dy) //if e.xfrac >= e.dy then begin
	{
		e->xfrac -= e->dy; //Dec(e.xfrac, e.dy);
		e->xint++; //Inc(e.xint);
	} //end;
	e->life--; //Dec(e.life);
}


void DrawTriAngleFill(T_Point *t) //procedure TriangleFill(t: TTriangle; Canvas: TCanvas);
{
	T_Edge shortedge, longedge; //shortedge, longedge: TEdge;
	uint16_t line; //line: Integer;
	uint16_t len;
	
	SwapVertices(t, 0, 1); //SwapVertices(t, 0, 1);
	SwapVertices(t, 1, 2); //SwapVertices(t, 1, 2);
	SwapVertices(t, 0, 1); //SwapVertices(t, 0, 1);
	
	longedge = InitEdge(t, 0, 2); //longedge := initedge(t, 0, 2);
	shortedge = InitEdge(t, 0, 1); //shortedge := initedge(t, 0, 1);
	line = t[0].Y; //line := t[0].y;
	
	while (shortedge.life > 0) //while shortedge.life > 0 do begin
	{
		len = shortedge.xint - longedge.xint; //Canvas.MoveTo(longedge.xint, line); Canvas.LineTo(shortedge.xint, line);
		///GUI_DrawLineDirection(longedge.xint, line, len, 0xFFFF, GUI_LINE_DIRECTION_HORIZONTAL); //void GUI_DrawLineDirection(uint16_t Pos_X, uint16_t Pos_Y, uint16_t Length, uint16_t Color, uint8_t Direction)
		
		line++; //Inc(Line)?;
		Advance(&longedge); //advance(longedge);
		Advance(&shortedge); //advance(shortedge);
	} //end;
	
	shortedge = InitEdge(t, 1, 2);
	
	while (longedge.life > 0)
	{
		len = shortedge.xint - longedge.xint; //Canvas.MoveTo(longedge.xint, line); Canvas.LineTo(shortedge.xint, line);
		///GUI_DrawLineDirection(longedge.xint, line, len, 0xFFFF, GUI_LINE_DIRECTION_HORIZONTAL); 
		
		line++; //Inc(Line)?;
		Advance(&longedge);
		Advance(&shortedge);
	}	
}
